'GENPI4.bas.  Generates PI4 symbols in packed bytes for export to PIC assembler

DEFLNG a - z      'other variables defined by suffix

FUNCTION PBMAIN()
    DIM sym%(146)
    allowed$ = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ /"

    sync$         = "001001111010101001000100011001"
    sync$ = sync$ + "111001111100110111101011011010"
    sync$ = sync$ + "000011111010100000111110100100"
    sync$ = sync$ + "101000010011000001100001100111"
    sync$ = sync$ + "01110110101010000111000011"

    DefaultMsg$ = "G4JNT   "

    PRINT : PRINT : PRINT
    PRINT "Generate PI4 Symbols for text message of up to 8 characters" : PRINT
    PRINT
    IF COMMAND$ = "" THEN LINE INPUT  "Message    ",m$ ELSE m$ = COMMAND$
    IF m$ = "" THEN m$ = DefaultMsg$

    m$ = UCASE$(m$) + SPACE$(8)
    m$ = LEFT$(m$ , 8)

    nc&& = 0            '64 bit integer
    COUNT = 0
    FOR x = 1 TO LEN(m$)
        ch$ = MID$(m$ , x , 1)
        c = INSTR(allowed$ , ch$)
        IF c = 0 THEN c = 37
        DECR c
        nc&& = nc&& * 38 + c
    NEXT x
             '------------- UNPACK THE MESSAGE -----------

    COLOR 13 : PRINT nc&& : COLOR 7
    regen$ = SPACE$(8)
    rnc&& = nc&&

    FOR x = 8 TO 1 STEP -1
        c = rnc&& MOD 38
        MID$(regen$ ,x , 1) = MID$(allowed$ , c + 1 , 1)
        rnc&& = rnc&& \ 38
    NEXT x



    COLOR 3 : PRINT "Packed message    '" ; regen$ ; "'" : COLOR 7

        '   -------- CHECKED OK against Bo's to HERE.   nc&& gives the same value -----

       PRINT BIN$(nc&&)

'.................................................................
    poly1 = -221228207      '0xF2D05351
    poly2 = -463389625      '0xE4613C47

    opstr$ = ""
    n1 = 0
    n2 = 0
    n = 0
           ' nc&&   contains the 42 bits of packed source data, right justified

    FOR i = 0 TO 72         '42 bits + 31 to flush out
        SHIFT LEFT n , 1
        'IF ((nc&& AND &H20000000000) <> 0) THEN BIT SET n , 0 ELSE BIT RESET n , 0
        IF BIT (nc&& , 41) THEN   BIT SET n , 0 ELSE BIT RESET n , 0
        SHIFT LEFT nc&&, 1
        CALL PARITY(n AND poly1 , even?)
        opstr$ = opstr$ + CHR$(even?)
        CALL PARITY(n AND poly2 , even?)
        opstr$ = opstr$ + CHR$(even?)
    NEXT i

    PRINT : COLOR 3
    PRINT "Convolved data" : COLOR 7
    FOR c% = 1 TO 146
        ch% = ASC(MID$(opstr$ , c% , 1)) + 48
        PRINT CHR$(ch%);
    NEXT c%

       '   -------- CHECKED OK against Bo's to HERE.   convolver bits give the same stream

'---------------------------------------------------------------
    PRINT : PRINT : COLOR 3
    PRINT "Interleaver output (Raw Data" : COLOR 7

    cnvstr$ = STRING$(146 , CHR$(0))
    p% = 0
    FOR i% = 0 TO 255
        FOR j% = 0 TO 7
            IF BIT (i%, j%) THEN BIT SET r%, 7 - j% ELSE BIT RESET r% , 7 - j%
        NEXT j%

        IF r% < 146 THEN
            MID$(cnvstr$ , r% + 1 , 1) = MID$(opstr$ , p% + 1 , 1)
            INCR p%
        END IF
    NEXT i%


    FOR c% = 1 TO 146
        ch% = ASC(MID$(cnvstr$ , c% , 1))
        PRINT USING$( "# "; ch%);
        IF c% MOD 30 = 0 THEN PRINT
    NEXT c%

    PRINT : PRINT
        '   -------- CHECKED OK against Bo's to HERE.   interleaver bits give same stream

'----------------------------------------------------
    COLOR 3 : PRINT "Symbols after merging with sync vector" : COLOR 7

    FOR c% = 1 TO 146
        sy% = VAL(MID$(sync$ , c% , 1))
        sym%(c% - 1) = sy% + 2 * ASC(MID$(cnvstr$ , c% , 1))
        PRINT USING$( "# ";sym%(c% - 1)) ;
        IF c% MOD 30 = 0 THEN PRINT
    NEXT c%
    PRINT : PRINT



          '   -------- CHECKED OK against Bo's to HERE.   symbols are the same

    COLOR 3 : PRINT "Packed Hex for export to PIC assembly"; : COLOR 7
'........................................................
    OPEN "PI4SYMBS.INC" FOR OUTPUT AS #1
    PRINT #1 , "    ;  PI4 Symbols  generated from GENPI4   [G4JNT Apr 2015]"
    PRINT #1 , "    ;  Message data '" + regen$ + "'"

    ch%= 0
    FOR c% = 0 TO 146
        IF c% MOD 4 = 3 THEN                'Last one here will be 146
            ch% = ch% + sym%(c%)
            hx$ = HEX$(ch%)
            IF ch% < 16 THEN hx$ = "0" + hx$
            PRINT USING$( "0x\\";hx$);
            PRINT #1, USING$( "0x\\";hx$);
            IF c% MOD 32 <> 31  THEN
                PRINT ", ";
                PRINT #1, ", ";
            END IF
            ch% = 0
        ELSE
            ch% = ch% + sym%(c%)
            SHIFT LEFT ch% , 2
        END IF

        IF c% MOD 32 = 0 THEN
            PRINT
            PRINT #1, ""
            PRINT #1 , "    de  ";
        END IF
    NEXT c%

        ' symbols remaining to align left
    SHIFT LEFT ch% , 4
    hx$ = HEX$(ch%)
    IF ch% < 16 THEN hx$ = "0" + hx$
    PRINT USING$( "0x\\ ";hx$);
    PRINT : PRINT
    COLOR 15
    PRINT "Symbols left justified packed four per byte in file  PI4SYMBS.INC"
    COLOR 7
    PRINT #1, USING$( "0x\\ ";hx$);

   CLOSE

    PRINT "Any key to finish..."
    WHILE NOT INSTAT : WEND

' -----------------------------------------------------------------------

END FUNCTION


SUB PARITY(m&, even?)
    even? = 0
    FOR b% = 0 TO 31
        IF BIT(m& , b%) THEN even? = 1 - even?
    NEXT b%
END SUB


FUNCTION fnLongHex$(n& , p%)
    hx$ = ""
    WHILE LEN(hx$)<= p%
        hx$ =  HEX$(n& AND &h0F) + hx$
        SHIFT RIGHT n& , 4
    WEND
    fnLongHex$ = hx$

END FUNCTION
