#include <stdio.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
//#include <conio.h>
#include <windows.h>   // or other WinApi header


void main(int argc, char *argv[]){

#ifndef TEXTMSG
   // pack call in n1

	char c[6], l[4], pwr[3];
	int dbm;

	HANDLE  hConsole;
	hConsole = GetStdHandle(STD_OUTPUT_HANDLE);

	if (argc != 4){
		SetConsoleTextAttribute(hConsole, 15 | BACKGROUND_RED );
		printf ("\nIncorrect number of arguments.   Usage ...  'GENWSPR CALL LOC POWER'");
		SetConsoleTextAttribute(hConsole, 11);
		printf ("\n\n     Callsign    ");
		scanf ("%s",c);
		printf ("     Locator     ");
		scanf ("%s",l);
		printf ("     Power       ");
		scanf ("%s" , pwr);
		printf ("\n");
		dbm = atoi(pwr);
		}
	else	{

//		printf("%s~%s~%s\n",argv[1], argv[2], argv[3]);
		strcpy(c, argv[1]);
		strcpy(l, argv[2]);
		dbm = atoi(argv[3]);
	}
	

	int nn;

	if (c[2]<'0' | c[2]>'9'){		//Ensure 3rd character is a number
	   for (nn = strlen(c)+1; nn > 0; nn--)  c[nn] = c[nn-1];	// if not, add preceding space
	   c[0] = 32;	  
	}
	
	if (strlen(c) < 6) {			// If Call < 6 characters pad with more spaces
	  for (nn = strlen(c) ; nn<6; nn++)   c[nn] = 32;
	}

	for (nn=0; nn<6; nn++) c[nn] = toupper(c[nn]);


	l[0] = toupper(l[0]);
	l[1] = toupper(l[1]);
	l[2] = (l[2] | 0x30) & 0x3F;	// Mask to Number
	l[3] = (l[3] | 0x30) & 0x3F;


   // all must be in uppercase
   // Callsign char at position 3 must be last digit of call prefix
   // left and right idented with space characters
   // dbm  must be in set {0,3,7,10,13,17,20,23,27,30,33,37,40,43,47,50,53,57,60}

   SetConsoleTextAttribute(hConsole, 14);

   printf ("\n\n\n\n      ------------------\n");
   printf ("     |   Call %c%c%c%c%c%c    |\n",c[0],c[1],c[2],c[3],c[4],c[5]);
   printf ("     |   Loc  %c%c%c%c      |\n",l[0],l[1],l[2],l[3]);


   unsigned long n1;
   n1=(c[0]>='0'&&c[0]<='9'?c[0]-'0':c[0]==' '?36:c[0]-'A'+10);
   n1=36*n1+(c[1]>='0'&&c[1]<='9'?c[1]-'0':c[1]==' '?36:c[1]-'A'+10);
   n1=10*n1+c[2]-'0';
   n1=27*n1+(c[3]== 32 ? 26:c[3]-'A');
   n1=27*n1+(c[4]== 32 ? 26:c[4]-'A');
   n1=27*n1+(c[5]== 32 ? 26:c[5]-'A');

   int ng  = 179 - ((l[0]-'A') * 10 + (l[2]-'0')) ;
   ng = 180 * ng + (l[1]-'A') * 10 + (l[3]-'0');

//   printf ("  Short Compact Loc %u \n",ng);

   unsigned long n2=(ng<<7)|(dbm+64);

   printf ("     |   dBm  %2d        |\n",dbm);
   printf ("      ------------------ \n\n");
   SetConsoleTextAttribute(hConsole, 7);

#else
   unsigned char msg[8] = "HI W0RLD";
   // pack text
   unsigned long long dn=0;
   int y;
   for(y=0;y!=8;y++){
      unsigned char c = msg[y];
      dn = 41*dn + (c>='0'&&c<='9'?c-'0': c>='A'&&c<='Z'?c-'A'+10: 
c=='+'?37: c=='.'?38: c=='/'?39: c=='?'?40: 36);
   }
   unsigned int ng=dn&0x7fff;	
   unsigned long n1=dn>>15;
   int ntype=-57;  //plain text
   unsigned long n2=ng<<7|(ntype+64);
#endif



   // pack n1,n2 into 50 bits
   unsigned char packed[11] = {n1>>20, n1>>12, n1>>4, (n1&0x0f)<<4|(n2>>18)&0x0f, 
        n2>>10, n2>>2, (n2&0x03)<<6, 0, 0, 0, 0};

	

   printf ("Source Coded N1 N2        %d %dx \n",n1,n2);
   printf ("          =               0x%08X 0x%08X \n",n1,n2);

   printf ("Source-Coded Characters  ");

   int y;
   for (y=0; y != 11 ; y++)
	printf("0x%02X " ,packed[y]);
	
   printf("\n");

   // Convolutional encoder for a K=32, r=1/2 code.
   // Layland-Lushbaugh polynomials for a K=32, r=1/2 convolutional code
   int k = 0;
   int i,j,p;
   int nstate = 0;
   unsigned char symbol[176];

   printf ("Convolver shift register states \n");

   for(j=0;j!=sizeof(packed);j++){
      for(i=7;i>=0;i--){
         unsigned long poly[2] = { 0xf2d05351L, 0xe4613c47L };
         nstate = (nstate<<1) | ((packed[j]>>i)&1);
	printf ("%08X  ",nstate);
         for(p=0;p!=2;p++){   //convolve
            unsigned long n = nstate & poly[p];
            // even := parity(n)
            int even = 0;
            while(n){
               even = 1 - even;
               n = n & (n - 1);
            }
            symbol[k] = even;
            k++;
         }
      }
   }

   printf ("\nConvolver output before Interleaving \n");
   
   for(i=0;i!=162;i++){
       printf ("%u ",symbol[i]);
       if (i % 32 == 31) printf ("\n");
	}

   printf("\n\nInterleaver output (raw data)\n");

   // Interleave symbols
   unsigned char symbol2[162], datasymbol;
   for(i=0;i!=162;i++){
      // j0 := bit reversed_values_smaller_than_161[i]
      unsigned char j0;
      p=-1;
      for(k=0;p!=i;k++){
         for(j=0;j!=8;j++)   // j0:=bit_reverse(k)
            j0 = ((k>>j)&1) | (j0<<1);
         if(j0<162)
         	p++;
      }
      symbol2[j0]=symbol[i]; //interleave

     
   }

    for(i=0;i!=162;i++){
       printf ("%u ",symbol2[i]);
       if (i % 32 == 31) printf ("\n");
	}


   // Sync vector 162 bits
    const unsigned char npr3[162] = {
      1,1,0,0,0,0,0,0,1,0,0,0,1,1,1,0,0,0,1,0,0,1,0,1,1,1,1,0,0,0,0,0,
      0,0,1,0,0,1,0,1,0,0,0,0,0,0,1,0,1,1,0,0,1,1,0,1,0,0,0,1,1,0,1,0,
      0,0,0,1,1,0,1,0,1,0,1,0,1,0,0,1,0,0,1,0,1,1,0,0,0,1,1,0,1,0,1,0,
      0,0,1,0,0,0,0,0,1,0,0,1,0,0,1,1,1,0,1,1,0,0,1,1,0,1,0,0,0,1,1,1,
      0,0,0,0,0,1,0,1,0,0,1,1,0,0,0,0,0,0,0,1,1,0,1,0,1,1,0,0,0,1,1,0,
      0,0 };

    printf ("\n\nEncoded Symbols\n");

    for(i=0;i!=162;i++){
      datasymbol = symbol2[i];
      symbol2[i] = npr3[i] | symbol2[i]<<1;
	printf ("%u ",symbol2[i]);

	if (i % 32 == 31)
	   printf("\n");	
   }
	printf ("\n\n");

	SetConsoleTextAttribute(hConsole, 15);
	printf ("Packed Symbols for Export   \n");

   unsigned char pp = 0;
   for(i=0;i!=162;i++){
      if (i % 4 == 0)
	{
	if (i>0) printf ("%02X ",pp);
	pp = symbol2[i];
        if (i % 32 == 0 & i>0) printf("\n");
	}
      else{
	pp = (pp << 2) | symbol2[i];   
	}
   }
	pp = (pp << 4) & 0xF0;
	printf ("%02X \n",pp);        // Final byte

	SetConsoleTextAttribute(hConsole, 7);

   //  Generate the include file
   FILE* ws = fopen("wsptones.inc", "w");



   fputs ("  ; WSPR Data Packed 4 symbols per byte - MSBits first\n", ws);

   fprintf (ws , "  ;%c%c%c%c%c%c ",c[0],c[1],c[2],c[3],c[4],c[5]);
   fprintf (ws , "%c%c%c%c ",l[0],l[1],l[2],l[3]);
   fprintf (ws , "%d         (Generated from 'GENWSPR.EXE'   G4JNT June 2009)\n", dbm);

   fputs ("  de ", ws);
   char hx[1];
   for(i=0;i!=162;i++){
    if (i % 4 == 0)
	{
	if (i>0) {				//  Turn pp into its hex representation
	  hx[1] = ((pp & 0xF0) >>4) + 0x30;
	  if (hx[1] > '9') hx[1] += 7;
          hx[0] = (pp & 0x0F)  + 0x30;
	  if (hx[0] > '9') hx[0] += 7;
		
	  fputs("0x", ws);
  	  fputc(hx[1], ws);
	  fputc(hx[0], ws);
	}

       	if (i % 32 == 0 & i>0)  {     // Tidy up the formatting a bit, 8 items per line
      	  fputc(0X0d, ws);
   	  fputc(0x0a, ws); 
  	  fputs("  de ", ws);
 	}

	else if (i!=0){
	   fputc(','  , ws);
	   fputc(' '  , ws);
	   }

	pp = symbol2[i];
     
	}
    else pp = (pp << 2) | symbol2[i];   
    }

   pp = (pp << 4) & 0xF0;
   hx[1] = ((pp & 0xF0) >>4) + 0x30;
   if (hx[1] > '9') hx[1] += 7;
   hx[0] = (pp & 0x0F)  + 0x30;
   if (hx[0] > '9') hx[0] += 7;
   fputs("0x", ws);
   fputc(hx[1], ws);
   fputc(hx[0], ws);

   fprintf(ws,"  ;  End of WSPR Data\n",ws);

   fclose (ws);

   printf ("\n Packed WSPR tone data stored in  WSPRTONES.INC - import into PIC .asm file \n\n");

   // Modulate
   FILE* pf = fopen("a.au", "wb");
   fputc(0x2e,pf); //.au magic number
   fputc(0x73,pf);
   fputc(0x6e,pf);
   fputc(0x64,pf);
   fputc(0x00,pf); //offset
   fputc(0x00,pf);
   fputc(0x00,pf);
   fputc(24,pf);
   fputc(0xff,pf); //size
   fputc(0xff,pf);
   fputc(0xff,pf);
   fputc(0xff,pf);
   fputc(0x00,pf); //encoding
   fputc(0x00,pf);
   fputc(0x00,pf);
   fputc(0x03,pf);
   fputc(0x00,pf); //samplerate
   fputc(0x00,pf);
   fputc(0x2e,pf);
   fputc(0xe0,pf);
   fputc(0x00,pf); //channels
   fputc(0x00,pf);
   fputc(0x00,pf);
   fputc(0x01,pf);

   const int nmax=120*12000;
   double tsymbol=8192.0/12000.0;
   double dt=1.0/12000.0;
   double f0=1500;
   double dfgen=12000.0/8192.0;
   double t=0;
   double dphi;
   double phi=0;
   double dj0=0;
   for(i=0; i!=nmax; i++){
      t=t+dt;
      j=(int)(t/tsymbol)+1;
      if(j!=dj0){
         double f=f0+dfgen*(symbol2[j]-1.5);
         dj0=j;
         dphi=2*3.14*dt*f;
      }
      phi=phi+dphi;
      int wave=32767.0*sin(phi);
      fputc((wave>>8)&0xff,pf);
      fputc(wave&0xff,pf);
   }
   fclose(pf);
}
